package supperSlonic.dynamoDBDAL;

import supperSlonic.amazonConnection.AmazonContext;
import supperSlonic.dynamoDBDAL.Table.DynamoDBTable;

import com.amazonaws.services.dynamodbv2.AmazonDynamoDBClient;
import com.amazonaws.services.dynamodbv2.datamodeling.DynamoDBMapper;
import com.amazonaws.services.dynamodbv2.datamodeling.DynamoDBMapperConfig;
import com.amazonaws.services.dynamodbv2.datamodeling.DynamoDBMapperConfig.TableNameOverride;

public class BaseDAL<TTable extends DynamoDBTable>
{
	protected TTable dynamoDBTable;
    protected DynamoDBMapper mapper;
    protected DynamoDBMapperConfig config;
    protected AmazonDynamoDBClient amazonDynamoDBClient;

    public BaseDAL(AmazonContext context, TTable table)
    {    
    	this.dynamoDBTable = table;
    	
    	this.amazonDynamoDBClient = new AmazonDynamoDBClient(context.getCredentials());
    	this.mapper = new DynamoDBMapper(this.amazonDynamoDBClient);
    	
    	this.config = this.CreateConfiguration();
    }
    
    protected DynamoDBMapperConfig CreateConfiguration()
    {
    	TableNameOverride tableName = new TableNameOverride(this.dynamoDBTable.getTableName());
    	return new DynamoDBMapperConfig(tableName);
    }
}
